(* 
 * Copyright (c) 2001 The University of Wroclaw.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Id: gonttypes.mli,v 1.5 2001/11/27 10:43:10 malekith Exp $
 *
 * Module interface: Gonttypes
 * Description:
 *)

open Gontutil

exception Type_error of string

(* Check whatever t is subtype of s (t < s).  *)
val global_subtype : (* s *) ty -> (* t *) ty -> unit

(* Return textual representation of given type. *)
val string_of_type : ty -> string

(* Return type of given expression. *)
val type_of : exp -> ty

(* Check whatever given declaration is type-correct (storing information
 * for type_of). Raise Syntax_error exception if there is an error. *)
val typecheck_decl : decl -> unit

(* Strip off any NamedType, leaving instained referenced type. *)
val instance_value : ty -> ty
;;
